import os
import platform as ps
import shutil as st
import requests
import urllib3
import urllib
import time
import cowsay
import random
import uuid
from .data import LinkObj
from bs4 import BeautifulSoup
from datetime import datetime
from termcolor import colored
from dotenv import load_dotenv
load_dotenv()


class Yk:
    def __randString(self, msg):
        txtcow = ['beavis', 'dragon', 'tux', 'turtle', 'ghostbusters', 'turkey', 'cheese', 'kitty', 'stegosaurus', 'daemon',
                'meow', 'cow', 'milk']
        i = random.randint(0, len(txtcow) - 1)
        if txtcow[i] == 'beavis':
            cowsay.beavis(msg)
        elif txtcow[i] == 'dragon':
            cowsay.dragon(msg)
        elif txtcow[i] == 'tux':
            cowsay.tux(msg)
        elif txtcow[i] == 'turtle':
            cowsay.turtle(msg)
        elif txtcow[i] == 'ghostbusters':
            cowsay.ghostbusters(msg)
        elif txtcow[i] == 'turkey':
            cowsay.turkey(msg)
        elif txtcow[i] == 'cheese':
            cowsay.cheese(msg)
        elif txtcow[i] == 'kitty':
            cowsay.kitty(msg)
        elif txtcow[i] == 'stegosaurus':
            cowsay.stegosaurus(msg)
        elif txtcow[i] == 'daemon':
            cowsay.daemon(msg)
        elif txtcow[i] == 'meow':
            cowsay.meow(msg)
        elif txtcow[i] == 'cow':
            cowsay.cow(msg)
        elif txtcow[i] == 'milk':
            cowsay.milk(msg)

        return txtcow[i]

    def __repartname(self, txt):
        return (str(txt).replace("b", "").strip()).replace("'", "")

    def __returnutfpono(self, txt):
        return self.__repartname(txt)

    def __trimtxt(self, txt):
        return str(txt).lstrip().rstrip()
    
    def __restrip(self, txt):
        return (txt).rstrip().lstrip()

    def __checkenvfile(self):
        pathenv = f".env"
        if os.path.exists(pathenv) == False:
            st.copy("./yazaki/env.example", pathenv)
        
        return True

    def __login(self):
        try:
            url = f"https://{os.getenv('HOST')}:{os.getenv('PORT')}/cehttp/servlet/MailboxServlet"
            payload = f"operation=LOGON&remote={os.getenv('USERCLOUD')}&password={urllib.parse.quote(os.getenv('PASSWORD'))}"
            headers = {'Content-Type': "application/x-www-form-urlencoded"}
            urllib3.disable_warnings()
            response = requests.request(
                "POST", url, data=payload, headers=headers, verify=False, timeout=3)
            return response.cookies

        except requests.RequestException as ex:
            print(ex)
            time.sleep(10)

            return self.__login()

    def __loadhtml(self,etd):
        obj = []
        if etd == None:
            etd = datetime.now()
        try:
            url = f"https://{os.getenv('HOST')}:{os.getenv('PORT')}/cehttp/servlet/MailboxServlet"
            passwd = urllib.parse.quote(os.getenv('PASSWORD'))
            payload = f"operation=LOGON&remote={os.getenv('USERCLOUD')}&password={passwd}"
            headers = {'Content-Type': "application/x-www-form-urlencoded"}
            urllib3.disable_warnings()
            response = requests.request("POST", url, data=payload, headers=headers, verify=False, timeout=3)
            if response.status_code == 200:
                pyload = f"operation=DIRECTORY&fromdate={str(etd.strftime('%Y%m%d'))}&Submit=Receive"
                # pyload = f"operation=DIRECTORY&fromdate=20200320&Submit=Receive"
                r = requests.request("POST", url, data=pyload, headers=headers, verify=False, timeout=3, cookies=response.cookies)
                type(r)
                soup = BeautifulSoup(r.text, 'html.parser')
                print(colored("===> Start Loop find Hyper-A tag.", "yellow"))
                for tr in soup.find_all('tr'):
                    found = True
                    i = 0
                    docs = []
                    for td in tr.find_all('td'):
                        txt = self.__restrip(td.text)
                        docs.append(txt)
                        if td.find("a") != None:
                            found = False

                        i += 1

                    if found != True:#check download is False to download
                        if len(docs) >= 9:
                            l = LinkObj(os.getenv('YAZAKI_TYPE'), docs[0], docs[1], str(docs[2]).replace(",", "").strip(), docs[3], f"{docs[4]} {docs[5]}", docs[6], docs[7], docs[8], found)
                            obj.append(l)


                response.cookies = None
                response.close()

            else:
                return obj

        except Exception as ex:
            print(ex)
            pass
        
        return obj

    def __loadtxtfile(self, objtype, mailbox, batchid, filename):
        linkname = f"https://{os.getenv('HOST')}:{os.getenv('PORT')}/cehttp/servlet/MailboxServlet?operation=DOWNLOAD&mailbox_id={mailbox}&batch_num={batchid}&data_format=A&batch_id={filename}"
        url = f"https://{os.getenv('HOST')}:{os.getenv('PORT')}/cehttp/servlet/MailboxServlet"
        passwd = urllib.parse.quote(os.getenv('PASSWORD'))
        payload = f"operation=LOGON&remote={os.getenv('USERCLOUD')}&password={passwd}"
        headers = {'Content-Type': "application/x-www-form-urlencoded"}
        urllib3.disable_warnings()
        response = requests.request("POST", url, data=payload, headers=headers, verify=False, timeout=3)
        docs = []
        txtfilename = filename
        if response.status_code == 200:
            rq = requests.get(linkname, stream=True, verify=False,
                              cookies=response.cookies, allow_redirects=True)
            response.cookies = None
            response.close()
            s = BeautifulSoup(rq.content, 'lxml')
            #CK ===>
            txtfile = ""
            if os.getenv("YAZAKI_TYPE") == "CK":
                txtfilename = str(linkname[len(linkname) - len("OES.WHAE.32T4.SPL.20200324100304.TXT"):]).replace("=", "").strip()
                txtfile = txtfilename[len(txtfilename) - len("20200320203000.TXT"):]
                txtfile = txtfile[:8]

            hname = f'{os.path.expanduser("~/")}{os.getenv("DIR_GEDI")}/{os.getenv("YAZAKI_TYPE")}/{objtype}/{datetime.now().strftime("%Y%m%d")}'
            filename = f'{hname}/{txtfile}'
            #CK END
            #RMW =>
            if os.getenv("YAZAKI_TYPE") == "RMW":
                hname = f'{os.path.expanduser("~/")}{os.getenv("DIR_GEDI")}/{objtype}/{datetime.now().strftime("%Y%m%d")}'
                filename = f'{hname}/{txtfilename}'

                if objtype == "KBDWLOAD":
                    txtfilename = txtfilename[len("NRRIS.32TE.SPL.IssueNo."):] 
                    filename = f'{hname}/{txtfilename}'


            if os.path.exists(hname) == False:
                os.makedirs(hname)

            if os.path.exists(filename) == True:
                os.remove(filename)


            f = open(filename, mode='a', encoding='ascii', newline='\r\n')
            if objtype != "LOTDWLOAD":
                for p in s.find_all('p'):
                    # \r\n append for win32,\n append for linux
                    f.write(p.text)
            else:
                for p in s:
                    # \r\n append for win32,\n append for linux
                    f.write(p.text)

            f.close()

            # with open(filename, 'w', encoding='utf-8') as f:
            #     f.write(f"{s.text}\n")
            #     f.close()
            
            docs = {'filename': txtfilename, 'path': filename, 'status': True}

        return docs

    def __read_ck_receive(self, filename):
        f = open(filename, 'r', encoding='utf-8')
        docs = []
        for i in f:
            fac = filename[filename.find('SPL') - 2:filename.find('SPL') - 1]
            uuidcode = str(uuid.uuid4())
            plantype = "RECEIVE"
            cd = 20
            unit = 'BOX'
            recisstype = '01'
            factory = 'INJ'
            if fac != "5":
                factory = 'AW'
                plantype = "RECEIVE"
                cd = 10
                unit = 'COIL'
                recisstype = '01'

            line = i
            docs.append({
                'factory': factory,
                "faczone": str(self.__trimtxt(line[4:(4 + 3)])),
                "receivingkey": str(self.__trimtxt(line[4:(4 + 12)])),
                "partno": str(self.__trimtxt(line[76:(76 + 25)])),
                "partname": str(self.__trimtxt(line[101:(101 + 25)])),
                'vendor': factory,
                'cd': cd,
                'unit': unit,
                'whs': factory,
                'tagrp': 'C',
                "recisstype": recisstype,
                "plantype": plantype,
                "recid": str(self.__trimtxt(line[0:4])),
                "aetono": str(self.__trimtxt(line[4:(4 + 12)])),
                "aetodt": str(self.__trimtxt(line[16:(16 + 10)])),
                "aetctn": float(str(self.__trimtxt(line[26:(26 + 9)]))),
                "aetfob": float(str(self.__trimtxt(line[35:(35 + 9)]))),
                "aenewt": float(str(self.__trimtxt(line[44:(44 + 11)]))),
                "aentun": str(self.__trimtxt(line[55:(55 + 5)])),
                "aegrwt": float(str(self.__trimtxt(line[60:(60 + 11)]))),
                "aegwun": str(self.__trimtxt(line[71:(71 + 5)])),
                "aeypat": str(self.__trimtxt(line[76:(76 + 25)])),
                "aeedes": str(self.__repartname(line[101:(101 + 25)])),
                "aetdes": str(self.__repartname(line[126:(126 + 25)])),
                "aetarf": float(str(self.__trimtxt(line[151:(151 + 10)]))),
                "aestat": float(str(self.__trimtxt(line[161:(161 + 10)]))),
                "aebrnd": float(str(self.__trimtxt(line[171:(171 + 10)]))),
                "aertnt": float(str(self.__trimtxt(line[181:(181 + 5)]))),
                "aetrty": float(str(self.__trimtxt(line[186:(186 + 5)]))),
                "aesppm": float(str(self.__trimtxt(line[191:(191 + 5)]))),
                "aeqty1": float(str(self.__trimtxt(line[196:(196 + 9)]))),
                "aeqty2": float(str(self.__trimtxt(line[205:(205 + 9)]))),
                "aeuntp": float(str(self.__trimtxt(line[214:(214 + 9)]))),
                "aeamot": float(str(self.__trimtxt(line[223:(223 + 11)]))),
                "plnctn": float(str(self.__trimtxt(line[26:(26 + 9)]))),
                "plnqty": float(str(self.__trimtxt(line[196:(196 + 9)]))),
                "minimum": 0,
                "maximum": 0,
                "picshelfbin": "PNON",
                "stkshelfbin": "SNON",
                "ovsshelfbin": "ONON",
                "picshelfbasicqty": 0,
                "outerpcs": 0,
                "allocateqty": 0,
                "sync": False,
                "uuid": uuidcode,
                "updatedon": datetime.now()
            })
        return docs

    def __read_ck_orderplan(self, filename):
        f = open(filename, 'r', encoding='utf-8')
        docs = []
        for line in f:
            fac = filename[filename.find('SPL') - 2:filename.find('SPL') - 1]
            uuidcode = str(uuid.uuid4())
            plantype = "ORDERPLAN"
            cd = 20
            unit = 'BOX'
            sortg1 = 'PARTTYPE'
            sortg2 = 'PARTNO'
            sortg3 = ''
            factory = "INJ"

            if fac != '5':
                factory = "AW"
                plantype = "ORDERPLAN"
                cd = 10
                unit = 'COIL'
                sortg1 = 'PONO'
                sortg2 = 'PARTTYPE'
                sortg3 = 'PARTNO'

            oqty = str(self.__trimtxt(line[89:(89 + 9)]))
            if oqty == "":
                oqty = 0

            docs.append({
                'vendor': factory,
                'cd': cd,
                'unit': unit,
                'whs': factory,
                'tagrp': 'C',
                'factory': factory,
                "sortg1": sortg1,
                "sortg2": sortg2,
                "sortg3": sortg3,
                "plantype": plantype,
                "orderid": str(self.__trimtxt(line[13:(13 + 15)])),
                "pono": str(self.__returnutfpono(line[13:(13 + 15)])),  # remove space
                "recid": str(self.__trimtxt(line[0:4])),
                "biac": str(self.__trimtxt(line[5:(5 + 8)])),
                "shiptype": str(self.__trimtxt(line[4:(4 + 1)])),
                "etdtap": datetime.strptime(str(self.__trimtxt(line[28:(28 + 8)])), '%Y%m%d'),
                "partno": str(self.__trimtxt(line[36:(36 + 25)])),
                "partname": str(self.__returnutfpono(line[61:(61 + 25)])),
                "pc": str(self.__trimtxt(line[86:(86 + 1)])),
                "commercial": str(self.__trimtxt(line[87:(87 + 1)])),
                "sampleflg": str(self.__trimtxt(line[88:(88 + 1)])),
                "orderorgi": int(oqty),
                "orderround": int(str(self.__trimtxt(line[98:(98 + 9)]))),
                "firmflg": str(self.__trimtxt(line[107:(107 + 1)])),
                "shippedflg": str(self.__trimtxt(line[108:(108 + 1)])),
                "shippedqty": float(str(self.__trimtxt(line[109:(109 + 9)]))),
                "ordermonth": datetime.strptime(str(self.__trimtxt(line[118:(118 + 8)])), '%Y%m%d'),
                "balqty": float(str(self.__trimtxt(line[126:(126 + 9)]))),
                "bidrfl": str(self.__trimtxt(line[135:(135 + 1)])),
                "deleteflg": str(self.__trimtxt(line[136:(136 + 1)])),
                "ordertype": str(self.__trimtxt(line[137:(137 + 1)])),
                "reasoncd": str(self.__trimtxt(line[138:(138 + 3)])),
                "upddte": datetime.strptime(str(self.__trimtxt(line[141:(141 + 14)])), '%Y%m%d%H%M%S'),
                "updtime": datetime.strptime(str(self.__trimtxt(line[141:(141 + 14)])), '%Y%m%d%H%M%S'),
                "carriercode": str(self.__trimtxt(line[155:(155 + 4)])),
                "bioabt": int(str(self.__trimtxt(line[159:(159 + 1)]))),
                "bicomd": str(self.__trimtxt(line[160:(160 + 1)])),
                "bistdp": float(str(self.__trimtxt(line[165:(165 + 9)]))),
                "binewt": float(str(self.__trimtxt(line[174:(174 + 9)]))),
                "bigrwt": float(str(self.__trimtxt(line[183:(183 + 9)]))),
                "bishpc": str(self.__trimtxt(line[192:(192 + 8)])),
                "biivpx": str(self.__trimtxt(line[200:(200 + 2)])),
                "bisafn": str(self.__trimtxt(line[202:(202 + 6)])),
                "biwidt": float(str(self.__trimtxt(line[212:(212 + 4)]))),
                "bihigh": float(str(self.__trimtxt(line[216:(216 + 4)]))),
                "bileng": float(str(self.__trimtxt(line[208:(208 + 4)]))),
                "lotno": str(self.__trimtxt(line[220:(220 + 8)])),
                "minimum": 0,
                "maximum": 0,
                "picshelfbin": "PNON",
                "stkshelfbin": "SNON",
                "ovsshelfbin": "ONON",
                "picshelfbasicqty": 0,
                "outerpcs": 0,
                "allocateqty": 0,
                "sync": False,
                "uuid": uuidcode,
                "updatedon": datetime.now()
            })
            print(f"found orderplan: {len(docs)}")

        return docs

    def getlink(self, etd=None):
        obj = self.__loadhtml(etd)
        return obj

    def gettextfile(self, objtype, mailbox, batchid, filename):
        obj = self.__loadtxtfile(objtype, mailbox, batchid, filename)
        return obj

    def readtextfile(self, objtype, filename):
        docs = []
        if os.getenv("YAZAKI_TYPE") != "CK":
            docs = {"error": True, "message": "Can' t read GEDI file!"}
        else:
            if objtype == "RECEIVE":
                print("RECEIVE")
                docs = self.__read_ck_receive(filename)
            else:
                print("ORDERPLAN")
                docs = self.__read_ck_orderplan(filename)
        return docs

    def uploadfilegedi(self, filename, batchid):
        url = f"https://{os.getenv('HOST')}:{os.getenv('PORT')}/cehttp/servlet/MailboxServlet"
        passwd = urllib.parse.quote(os.getenv('PASSWORD'))
        payload = f"operation=LOGON&remote={os.getenv('USERCLOUD')}&password={passwd}"
        headers = {'Content-Type': "application/x-www-form-urlencoded"}
        urllib3.disable_warnings()
        response = requests.request("POST", url, data=payload, headers=headers, verify=False, timeout=3)
        docs = False
        if response.status_code == 200:
            try:
                f = open(filename, 'r', encoding='ascii')
                files = {'filename': (f"{batchid}", f)}
                values = {
                    "operation": "UPLOAD",
                    "data_format": "A",
                    "mailbox_id": f"{os.getenv('MAIL_TO')}",
                    "batch_id": f"{batchid}",
                    "put_flag": "transmit",
                    "sourcefile": f"{files}"
                }
                r = requests.post(url, files=files, data=values,
                                  verify=False, timeout=20, cookies=response.cookies)
                soup = BeautifulSoup(r.text, 'html.parser')
                print(soup)
                docs = True
                # os.remove(f"temp/{batchid}")
                response.cookies = None
                response.close()

            except requests.RequestException as ex:
                print(colored(ex, "red"))
                docs = False
        
        return docs


    def linenotifies(self, message):
        url = "https://notify-api.line.me/api/notify"
        payload = f"message={message}"
        headers = {
            'Content-Type': "application/x-www-form-urlencoded",
            'Authorization': f"Bearer {os.getenv('LINE_TOKEN')}",
            'Accept': "*/*",
            'Cache-Control': "no-cache",
            'Host': "notify-api.line.me",
            'Accept-Encoding': "gzip, deflate",
            'Content-Length': "12",
            'Connection': "keep-alive",
            'cache-control': "no-cache"
        }
        response = requests.request("POST", url, data=payload, headers=headers)
        return response.text

    def __init__(self):
        print(colored(f"{ps.system()}({ps.release()})", "yellow"))
        print(colored("Create by Mr.Taweechai Yuenyang", "yellow"))
        print(colored("E-Mail: krumii.it@gmail.com", "yellow"))
        self.__randString(colored("WARNING!Package for 'SPL' only!", "red"))
        self.__checkenvfile()
        pass

if __name__ == "__main__":
    pass